/* 
 ofpec_ils.sqf v1.0
 August 2007 Mandoble 
*/

if (isNil "MandoWorldToScreen") then
{
   MandoWorldToScreen = 
   {
      private["_target", "_vehicle", "_pos", "_posu", "_disth", "_distv", "_hscreen", "_vscreen", "_sinvscreen", "_angh", "_angv", "_vdir"];
      _target = _this select 0;
      _vehicle = _this select 1;

      _pos = (_vehicle) worldToModel (getPos _target);
      _disth = sqrt((_pos select 0)^2+(_pos select 1)^2);
      _distv = sqrt(((getPosASL _target select 2) - (getPosASL (_vehicle) select 2))^2+_disth^2);

      if (_disth < 0.1) then
      {
         _disth = 0.1;
      };
      if (_distv < 0.1) then
      {
         _distv = 0.1;
      };
      _sinvscreen = (_pos select 2)/_distv;
   
      _angh = (_pos select 0) atan2 (_pos select 1);
      _angv  = asin(_sinvscreen);
      _hscreen = 0.5 + _angh*0.5/42;
      _vscreen = 0.5 - _angv*0.5/35;      

      [_hscreen, _vscreen, _angh, _angv]
   };
};


private["_disp", "_vehicle", "_mark", "_type", "_altc", "_range", "_dist", "_hscreen", "_vscreen", "_screen", "_angh", "_angv", "_continue", "_alt", "_logic", "_glide", "_i", "_aim", "_aim2", "_messages", "_ilsPosition", "_ilsDirection", "_logic", "_logic2", "_logic3", "_ilspos", "_map", "_ischopper", "_ils", "_ilsoffact", "_runwayalt", "_landspeed", "_maxspeed","_speeds", "_speedw", "_altw", "_blink", "_blinkdir", "_cname", "_lastsoundtime", "_sounds"];

_vehicle = _this select 0;
_ilsName = _this select 1;
_ilsPosition = _this select 2;
_ilsDirection = _this select 3;


_ilsoffact = _vehicle addAction ["ILS OFF", "ofpec_ils\ofpec_ils_off.sqf"];


_ischopper = false;
_cname = typeOf _vehicle;
while {_cname != "All"} do
{
   _cname = configName (inheritsFrom (configFile >> "CfgVehicles" >> _cname));
   if (_cname == "Helicopter") then
   {
      _ischopper = true;      
   };
};

if (!_ischopper) then
{
   _landspeed =  getNumber (configFile >> "CfgVehicles" >> typeOf _vehicle >> "landingSpeed");
   _maxspeed =  getNumber (configFile >> "CfgVehicles" >> typeOf _vehicle >> "maxSpeed");
};


ofpec_ils_disp = displayNull;
ofpec_ils = true;

cutRsc["ofpec_ils", "PLAIN"];
waitUntil {!isNull ofpec_ils_disp};

_disp   = ofpec_ils_disp;
_horb   = _disp displayCtrl 102;
_verb   = _disp displayCtrl 103;
_aim    = _disp displayCtrl 104;
_aim2   = _disp displayCtrl 105;
_type   = _disp displayCtrl 106;
_range  = _disp displayCtrl 107;
_altc   = _disp displayCtrl 108;
_map    = _disp displayCtrl 109;
_speedw = _disp displayCtrl 111;
_altw   = _disp displayCtrl 112;


_glide = _ilsDirection select 1;

_ilsPosition = [(_ilsPosition select 0)-(_ilsDirection select 0)*50,(_ilsPosition select 1)-(_ilsDirection select 2)*50, 0];

_logic = "logic" createVehicleLocal [_ilsPosition select 0,_ilsPosition select 1, 0];
_logic2 = "logic" createVehicleLocal [_ilsPosition select 0,_ilsPosition select 1, 0];
_logic3 = "logic" createVehicleLocal [_ilsPosition select 0,_ilsPosition select 1, 0];
_runwayalt = getPosASL _logic select 2;


_messages = ["First WP", "Second WP", "Landing WP"];
_sounds = ["", "ofpec_firstwp","ofpec_final_aproach"];
_speeds = [_maxspeed * 2/3, _maxspeed/2, _landspeed + _landspeed * 1/4];


createMarkerLocal ["ofpec_ils", [0,0]];
"ofpec_ils" setMarkerShapeLocal "RECTANGLE";
"ofpec_ils" setMarkerColorLocal "ColorWhite";
"ofpec_ils" setMarkerSizeLocal [4, 100];

createMarkerLocal ["ils_plane", [0,0]];
"ils_plane" setMarkerColorLocal "ColorGreen";
"ils_plane" setMarkerSizeLocal [1, 1];
"ils_plane" setMarkerTypeLocal "Arrow";
"ils_plane" setMarkerSizeLocal [0.5, 0.5];

createMarkerLocal ["ils_plane2", [0,0]];
"ils_plane2" setMarkerColorLocal "ColorGreen";
"ils_plane2" setMarkerSizeLocal [1, 1];
"ils_plane2" setMarkerTypeLocal "Select";
"ils_plane2" setMarkerSizeLocal [0.6, 0.6];



createMarkerLocal ["ils_wp", [0,0]];
"ils_wp" setMarkerColorLocal "ColorGreen";
"ils_wp" setMarkerSizeLocal [1, 1];
"ils_wp" setMarkerTypeLocal "Arrow";
"ils_wp" setMarkerSizeLocal [0.5, 0.5];

_ilspos = [];
_ilspos = _ilspos + [[(_ilsPosition select 0)+(_ilsDirection select 0)*6000,(_ilsPosition select 1)+(_ilsDirection select 2)*6000, _runwayalt+_glide*6000]];

_ilspos = _ilspos + [[(_ilsPosition select 0)+(_ilsDirection select 0)*3000,(_ilsPosition select 1)+(_ilsDirection select 2)*3000, _runwayalt+_glide*3000]];

_ilspos = _ilspos + [getPosASL _logic];

_ilspos = _ilspos + [[(_ilsPosition select 0)+(_ilsDirection select 0)*-200,(_ilsPosition select 1)+(_ilsDirection select 2)*-200, _runwayalt]];


if (!_ischopper) then
{
   _ils = 0;
}
else
{
   _ils = 2;
   _aim ctrlSetTextColor [0, 0.5, 0, 0];
   _aim2 ctrlSetTextColor [0, 0.5, 0, 0];
};


_logic setPosASL (_ilspos select _ils);
_logic2 setPosASL [((_ilspos select _ils) select 0)-(_ilsDirection select 0)*1000,((_ilspos select _ils) select 1)-(_ilsDirection select 2)*1000, ((_ilspos select _ils) select 2)-_glide*1000];

_logic3 setPosASL [((_ilspos select _ils) select 0)+(_ilsDirection select 0)*1000,((_ilspos select _ils) select 1)+(_ilsDirection select 2)*1000, ((_ilspos select _ils) select 2)+_glide*1000];


"ils_wp" setMarkerPosLocal getPos _logic;
"ils_wp" setMarkerDirLocal ((getPos _logic2 select 0) - (getPos _logic select 0)) atan2 ((getPos _logic2 select 1) - (getPos _logic select 1));

playSound "ofpec_enabled";
_lastsoundtime = dayTime * 3600;

_type ctrlSetText format["%1: %2", _ilsName, (_messages select _ils)];   



_continue = true;
_blink = 0;
_blinkdir = 1;
while {_continue && (vehicle player == _vehicle) && ofpec_ils && ((getPos _vehicle select 2) > 1)} do
{
   _map ctrlMapAnimAdd [0.01, 1, getPos _vehicle];
   ctrlMapAnimCommit _map; 

   _alt  = getPos _logic select 2;
   _alt = _alt - _alt % 1;

   _alt2 = (getPosASL _vehicle select 2) - (getPosASL _logic select 2);
   _alt2 = _alt2 - _alt2 % 1;

   _dist = sqrt(((getPos _logic select 0) - (getPos _vehicle select 0))^2+((getPos _logic select 1) - (getPos _vehicle select 1))^2);    
   _dist = _dist - _dist % 1;

   _altc ctrlSetText format["Altitudes: %1 m / %2 m", _alt, _alt2];
   _range ctrlSetText format["Range: %1 m", _dist];
   
   _angle = ((getPos _logic select 0) - (getPos _vehicle select 0)) atan2 ((getPos _logic select 1) - (getPos vehicle player select 1));
   
   "ofpec_ils" setMarkerPosLocal [(getPos _vehicle select 0)+sin(_angle)*_dist/2, (getPos _vehicle select 1)+cos(_angle)*_dist/2];
   "ofpec_ils" setMarkerDirLocal _angle;
   "ofpec_ils" setMarkerSizeLocal [4, _dist/2];

   "ils_plane" setMarkerPosLocal getPos _vehicle;
   "ils_plane" setMarkerDirLocal getDir _vehicle;
   "ils_plane2" setMarkerPosLocal getPos _vehicle;

   _screen = [_logic, _vehicle] call MandoWorldToScreen;   
   _hscreen = (_screen select 0) - 0.04/2;
   _vscreen = (_screen select 1) - 0.05/2;
   _hscreen = _hscreen min (0.6-0.04);
   _hscreen = _hscreen max (0.4);
   _vscreen = _vscreen min (0.6-0.05);
   _vscreen = _vscreen max (0.4);
   _angh = _screen select 2;
   _angv = _screen select 3;

   if (abs(_angh) < 10) then
   {
      _verb ctrlSetTextColor [0, 1, 0, 1];
   }
   else
   {
      _verb ctrlSetTextColor [0, 0.5, 0, 0.5];
   };


   if (abs(_angv) < 10) then
   {
      _horb ctrlSetTextColor [0, 1, 0, 1];
   }
   else
   {
      _horb ctrlSetTextColor [0, 0.5, 0, 0.5];
   };

   _horb ctrlSetPosition [0.4, _vscreen];
   _horb ctrlCommit 0;
   _verb ctrlSetPosition [_hscreen, 0.4];
   _verb ctrlCommit 0;

   if (!_ischopper) then
   {
      if (speed _vehicle > (_speeds select _ils)) then
      {
         if ((dayTime * 3600 - _lastsoundtime) > 4) then
         {
            playSound "ofpec_toofast";
            _lastsoundtime = dayTime * 3600;
         };
         _speedw ctrlSetText "Too fast";
      }
      else
      {
         if (speed _vehicle < _landspeed) then
         {
            if ((dayTime * 3600 - _lastsoundtime) > 4) then
            {
               playSound "ofpec_tooslow";
               _lastsoundtime = dayTime * 3600;
            };

            _speedw ctrlSetText "Too slow";
         }
         else
         {
            _speedw ctrlSetText "";
         };
      };


      if ((getPosASL _vehicle select 2) > ((getPosASL _logic3 select 2)+50)) then
      {
         if ((dayTime * 3600 - _lastsoundtime) > 4) then
         {
            playSound "ofpec_toohigh";
            _lastsoundtime = dayTime * 3600;
         };

         _altw ctrlSetText "Too high";
      }
      else
      {
         if ((getPosASL _vehicle select 2) < (getPosASL _logic select 2)) then
         {
            if ((dayTime * 3600 - _lastsoundtime) > 4) then
            {
               playSound "ofpec_toolow";
               _lastsoundtime = dayTime * 3600;
            };

            _altw ctrlSetText "Too low";
         }
         else
         {
            _altw ctrlSetText "";
         };
      };


      _screen = [_logic2, _vehicle] call MandoWorldToScreen;   
      if (abs (_screen select 2) < 45) then
      {
         _hscreen = (_screen select 0) - 0.04/2;
         _vscreen = (_screen select 1) - 0.05/2;
         _hscreen = _hscreen min (0.6-0.04);
         _hscreen = _hscreen max (0.4);
         _vscreen = _vscreen min (0.6-0.05);
         _vscreen = _vscreen max (0.4);
         _aim ctrlSetPosition [_hscreen, _vscreen];
         _aim ctrlCommit 0;
         _aim ctrlSetTextColor [0, 0.5, 0, 0.5];
      }
      else
      {
         _aim ctrlSetTextColor [0, 0.5, 0, 0];
      };

      _screen = [_logic3, _vehicle] call MandoWorldToScreen;   
      if (abs (_screen select 2) < 45) then
      {
         _hscreen = (_screen select 0) - 0.04/2;
         _vscreen = (_screen select 1) - 0.05/2;
         _hscreen = _hscreen min (0.6-0.04);
         _hscreen = _hscreen max (0.4);
         _vscreen = _vscreen min (0.6-0.05);
         _vscreen = _vscreen max (0.4);
         _aim2 ctrlSetPosition [_hscreen, _vscreen];
         _aim2 ctrlCommit 0;
         _aim2 ctrlSetTextColor [0, 0.5, 0, 0.5];
      }
      else
      {
         _aim2 ctrlSetTextColor [0, 0.5, 0, 0];
      };
   };


   if (_dist < 200) then
   {
      if (_ils < ((count _ilspos)-2)) then 
      {
         _ils = _ils + 1;
         _logic setPosASL (_ilspos select _ils);
         _logic2 setPosASL [((_ilspos select _ils) select 0)-(_ilsDirection select 0)*1000,((_ilspos select _ils) select 1)-(_ilsDirection select 2)*1000, ((_ilspos select _ils) select 2)-_glide*1000];
         _logic3 setPosASL [((_ilspos select _ils) select 0)+(_ilsDirection select 0)*1000,((_ilspos select _ils) select 1)+(_ilsDirection select 2)*1000, ((_ilspos select _ils) select 2)+_glide*1000];


         _type ctrlSetText format["%1: %2", _ilsName, _messages select _ils];
         playSound (_sounds select _ils);
         _lastsoundtime = dayTime * 3600;

         "ils_wp" setMarkerPosLocal getPos _logic;
         "ils_wp" setMarkerDirLocal ((getPos _logic2 select 0) - (getPos _logic select 0)) atan2 ((getPos _logic2 select 1) - (getPos _logic select 1));
   
      }
      else
      {
         _continue = false;
      };
   };

   if (_blink % 20 == 0) then
   {
      if (_blinkdir == 1) then
      {
         _speedw ctrlSetTextColor [0, 1, 0, 1];
         _altw ctrlSetTextColor [0, 1, 0, 1];
      }
      else
      {
         _speedw ctrlSetTextColor [0, 1, 0, 0];
         _altw ctrlSetTextColor [0, 1, 0, 0];
      };
      _blinkdir = -_blinkdir;
   };
   
   _blink = _blink + 1;
   if (_blink == 2000) then
   {
      _blink = 0;
   };


   Sleep 0.01;

   if (isNull ofpec_ils_disp && _continue) then
   {
      cutRsc["ofpec_ils", "PLAIN"];
      waitUntil {!isNull ofpec_ils_disp};
   };
};


deleteVehicle _logic;
deleteVehicle _logic2;
deleteVehicle _logic3;
deleteMarkerLocal "ils_plane";
deleteMarkerLocal "ils_plane2";
deleteMarkerLocal "ils_wp";
deleteMarkerLocal "ofpec_ils";


cutText["", "PLAIN"];
ofpec_ils = false;
_vehicle removeAction _ilsoffact;
_vehicle addAction ["Call ILS", "ofpec_ils\ofpec_open_airfieldselector.sqf"]